package filter;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpServletResponseWrapper;

/**
 * Section 3.3 X|X̃bp[NX 
 * Servlet ɂāAResponse ɑ΂ď񂾒lAByteArrayOutputStream ɕێA
 * getInputStream() 擾ł悤ɂ
 * 
 * tB^ݒ肵ANGXg܂̓X|X̃bp[쐬B
 * ݌v̕s΁AtB^܂̓bp[Kp
 * @author Yagi Hiroto
 */
public class BufferedResponseWrapper extends HttpServletResponseWrapper {
	
	private ByteArrayOutputStream baos = new ByteArrayOutputStream();
	private PrintWriter pw = new PrintWriter(baos);
	private ByteArrayServletOutputStream basos = new ByteArrayServletOutputStream(baos);
	
	public BufferedResponseWrapper(HttpServletResponse response) {
		super(response);
	}

	@Override
	public PrintWriter getWriter() throws IOException {
		return pw;
	}
	
	@Override
	public ServletOutputStream getOutputStream() throws IOException {
		return basos;
	}
	
	public ByteArrayInputStream getInputStream() throws IOException {
		pw.flush();
		return new ByteArrayInputStream(baos.toByteArray());
	}
	
	private static class ByteArrayServletOutputStream extends ServletOutputStream  {

		ByteArrayOutputStream out = null;
		public ByteArrayServletOutputStream(ByteArrayOutputStream out) {
			this.out = out;
		}
		
		@Override
		public void write(int c) throws IOException {
			out.write(c);
		}
	}
}
