package filter;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletResponse;

/**
 * Section 3.3 Wikȉ̂悤ȕҏWstB^ 
 * 
 * ServletɃX|X̃bp[CX^XnA
 * X|X̃bp[ւ̏o͂tB^
 * 
 * WebReĩNGXgf: 
 * tB^ݒ肵ANGXg܂̓X|X̃bp[쐬B
 * ݌v̕s΁AtB^܂̓bp[Kp
 * 
 * @author Yagi Hiroto
 */
public class Section3_3_1Filter implements Filter {
	private FilterConfig config = null;
	
	/* (non-Javadoc)
	 * @see javax.servlet.Filter#init(javax.servlet.FilterConfig)
	 */
	public void init(FilterConfig config) throws ServletException {
		this.config = config;
	}

	/* (non-Javadoc)
	 * @see javax.servlet.Filter#doFilter(javax.servlet.ServletRequest, javax.servlet.ServletResponse, javax.servlet.FilterChain)
	 */
	public void doFilter(ServletRequest request, ServletResponse response, FilterChain filterChain) throws IOException, ServletException {

		request.setCharacterEncoding("Shift_JIS");
		
		// X|Xbp[̐
		BufferedResponseWrapper wikiResponse 
			= new BufferedResponseWrapper((HttpServletResponse)response);
		
		// Servlet(܂́AtB^[`FC)̌Ăяo
		filterChain.doFilter(request, wikiResponse);
		
		// X|Xɑ΂o͂ǂݍ
		BufferedReader reader 
			= new BufferedReader(new InputStreamReader(wikiResponse.getInputStream()));
		
		response.setCharacterEncoding("Shift_JIS");
		
		//@WikiAHTMLւ̕ϊtB^̓o^
		List<LineFilter> filterList = new ArrayList<LineFilter>();
		filterList.add(new HeadLineFilter());
		filterList.add(new TableFilter());
		filterList.add(new ListItemFilter());
		filterList.add(new HorizontalLineFilter());
		
		// NCAg֏o
		PrintWriter out = response.getWriter();
		out.println("<html><head><title>Section 3.3</title></head><body>");
		String line = null;
		while ((line = reader.readLine()) != null) {
			for (int i=0; i<filterList.size(); i++) {
				LineFilter filter = filterList.get(i);
				line = filter.doFilter(line);
			}
			out.println(line);
		}
		out.println("</body></html>");
	}

	/* (non-Javadoc)
	 * @see javax.servlet.Filter#destroy()
	 */
	public void destroy() {
		
	}
	
	/**
	 * Wiki To Html tB^NX
	 * @author Yagi Hiroto
	 */
	private static abstract class LineFilter {
		
		abstract String doFilter(String line);
	}
	
	/**
	 * H1 ~ H3^OtB^ Ci[NX
	 * @author Yagi Hiroto
	 */
	private static class HeadLineFilter extends LineFilter {
		
		@Override
		String doFilter(String line) {
			if (line == null) return "";
			if (line.indexOf("!!!") == 0) {
				return "<h1>" + line.substring(3) + "</h1>";
			}
			if (line.indexOf("!!") == 0) {
				return "<h2>" + line.substring(2) + "</h2>";
			}
			if (line.indexOf("!") == 0) {
				return "<h3>" + line.substring(1) + "</h3>";
			}
			return line;
		}
	}

	/**
	 * HR ^OtB^ Ci[NX
	 * @author Yagi Hiroto
	 */
	private static class HorizontalLineFilter extends LineFilter {
		
		@Override
		String doFilter(String line) {
			if (line == null) return "";
			if (line.indexOf("----") == 0) {
				return "<hr/>" + line.substring(4);
			}
			return line;
		}
	}
	
	/**
	 * TABLE ^OtB^ Ci[NX
	 * @author Yagi Hiroto
	 */
	private static class TableFilter extends LineFilter {
		
		private boolean inTag = false;
		private int rowCnt = 0;
		
		@Override
		public String doFilter(String line) {
			if (line == null) return "";
			StringBuffer buf = new StringBuffer();
			boolean isTagEscape = false;
			line = line.trim();
			if (line.length() > 0) {
				isTagEscape = (line.charAt(0) == ',');
				if (!inTag && isTagEscape) {
					buf.append("<table border='1'>");
				}
				if (isTagEscape) {
					buf.append(replace(line, rowCnt));
					rowCnt++;
				} else {
					buf.append(line);
				}
				if (inTag && !isTagEscape) {
					buf.append("</table>");
					rowCnt = 0;
				}
				inTag = isTagEscape;
			}
			return buf.toString();
		}
		private String replace(String line, int rowCnt) {
			String sTag = (rowCnt == 0)?"<th>":"<td>";
			String eTag = (rowCnt == 0)?"</th>":"</td>";
			
			StringBuffer buf = new StringBuffer();
			buf.append("<tr>");
			StringTokenizer tok = new StringTokenizer(line, ",");
			while(tok.hasMoreTokens()) {
				buf.append(sTag);
				buf.append(tok.nextToken());
				buf.append(eTag);
			}
			buf.append("</tr>");
			return buf.toString();
		}
	}
	
	/**
	 * UL ^OtB^ Ci[NX
	 * @author Yagi Hiroto
	 */
	private static class ListItemFilter extends LineFilter {
		
		private boolean inTag = false;
		
		@Override
		public String doFilter(String line) {
			if (line == null) return "";
			StringBuffer buf = new StringBuffer();
			line = line.trim();
			boolean isTagEscape = (line.indexOf("*") == 0);
			if (!inTag && isTagEscape) {
				buf.append("<ul>");
			}
			if (isTagEscape) {
				buf.append("<li>" + line.substring(1) + "</li>");
			} else {
				buf.append(line);
			}
			if (inTag && !isTagEscape) {
				buf.append("</ul>");
			}
			inTag = isTagEscape;
		
			return buf.toString();
		}
	}
}
