package listener;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Date;

public class BufferedLog {
	
	private StringBuffer buf = null;
	private int bufferedSize = 0;
	private int size = 0;
	
	private FileWriter writer = null;
	private File logFile = null;
	
	public BufferedLog(String path, int size) {
		buf = new StringBuffer(size);
		this.size = size;
		logFile = new File(path);
	}
	
	public void println(String value) {
		if (value == null) value ="null";
		value = (new Date().toString()) + " " + value;
		
		bufferedSize += (value.length() + 2);
		
		if (bufferedSize > size) {
			flush();
		}
		synchronized (this) {
			buf.append(value + "\r\n");
		}
		
		System.out.println(value);
	}
	
	public void flush() {
		try {
			writer = new FileWriter(this.logFile);
			writer.append(buf.toString());
			writer.flush();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if (writer != null) writer.close();
			} catch (Exception e){}
		}
		
		buf = new StringBuffer(this.size);
		bufferedSize = 0;
	}
	
	public String toString() {
		return buf.toString();
	}
}
