package listener;

import javax.servlet.ServletContextAttributeEvent;
import javax.servlet.ServletContextAttributeListener;
import javax.servlet.ServletContextEvent;

public class ScwcdContextAttributeListener implements ServletContextAttributeListener {

	/* (non-Javadoc)
	 * @see javax.servlet.ServletContextAttributeListener#attributeAdded(javax.servlet.ServletContextAttributeEvent)
	 */
	public void attributeAdded(ServletContextAttributeEvent event) {

		BufferedLog log = getLog(event);
		log.println("ServletContextAttributeListener.attributeAdded : " + event.getName());
	}

	/* (non-Javadoc)
	 * @see javax.servlet.ServletContextAttributeListener#attributeRemoved(javax.servlet.ServletContextAttributeEvent)
	 */
	public void attributeRemoved(ServletContextAttributeEvent event) {
		
		BufferedLog log = getLog(event);
		log.println("ServletContextAttributeListener.attributeRemoved : " + event.getName());
	}

	/* (non-Javadoc)
	 * @see javax.servlet.ServletContextAttributeListener#attributeReplaced(javax.servlet.ServletContextAttributeEvent)
	 */
	public void attributeReplaced(ServletContextAttributeEvent event) {
		
		BufferedLog log = getLog(event);
		log.println("ServletContextAttributeListener.attributeReplaced : " + event.getName());
	}

	private BufferedLog getLog(ServletContextEvent event) {
		
		return (BufferedLog) event.getServletContext().getAttribute(BufferedLog.class.getName());
	}
}
