package listener;

import javax.servlet.ServletContext;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;

public class ScwcdContextListener implements ServletContextListener {

	/* (non-Javadoc)
	 * @see javax.servlet.ServletContextListener#contextInitialized(javax.servlet.ServletContextEvent)
	 */
	public void contextInitialized(ServletContextEvent event) {
		
		ServletContext context = event.getServletContext();
		
		String path = context.getRealPath("/log/scwcd.log");
		BufferedLog log = new BufferedLog(path, 10240);
		
		log.println("ServletContextListener.contextInitialized()");
		
		context.setAttribute(BufferedLog.class.getName(), log);
	}

	/* (non-Javadoc)
	 * @see javax.servlet.ServletContextListener#contextDestroyed(javax.servlet.ServletContextEvent)
	 */
	public void contextDestroyed(ServletContextEvent event) {
		
		BufferedLog log = getLog(event);
		log.println("ServletContextListener.contextDestroyed()");
		// Web Application I邽 t@Cɏ
		log.flush();
		
	}
	
	private BufferedLog getLog(ServletContextEvent event) {
		
		return (BufferedLog) event.getServletContext().getAttribute(BufferedLog.class.getName());
	}
}
