package listener;

import javax.servlet.http.HttpSessionAttributeListener;
import javax.servlet.http.HttpSessionBindingEvent;
import javax.servlet.http.HttpSessionEvent;

public class ScwcdHttpSessionAttributeListener implements HttpSessionAttributeListener {

	public void attributeAdded(HttpSessionBindingEvent event) {

		BufferedLog log = getLog(event);
		log.println("HttpSessionAttributeListener.attributeAdded() [" 
				+ event.getName() + "=" + event.getValue().toString() + "]");
		
	}

	public void attributeRemoved(HttpSessionBindingEvent event) {

		BufferedLog log = getLog(event);
		log.println("HttpSessionAttributeListener.attributeRemoved() [" 
				+ event.getName() + "=" + event.getValue().toString() + "]");
		
	}

	public void attributeReplaced(HttpSessionBindingEvent event) {

		BufferedLog log = getLog(event);
		log.println("HttpSessionAttributeListener.attributeReplaced() [" 
				+ event.getName() + "=" + event.getValue().toString() + "]");
		
	}

	private BufferedLog getLog(HttpSessionEvent event) {
		
		return (BufferedLog) event.getSession().getServletContext().getAttribute(BufferedLog.class.getName());
	}	
}
