package servlet;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.Date;

import javax.servlet.ServletException;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class Section1_3Servlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
	
	@Override
	protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		
		String testId = request.getParameter("testId");
		
		if ("1".equals(testId)) {
			doTest1(request, response);
		}
		if ("2".equals(testId)) {
			doTest2(request, response);
		}
		if ("3".equals(testId)) {
			doTest3(request, response);
		}
		if ("4".equals(testId)) {
			doTest4(request, response);
		}
	}
	
	/**
	 * <ol>
	 * <li>X|Xwb_ݒ肷</li>
	 * <li>X|XIuWFNg̃Rec^Cvݒ肷</li>
	 * <li>X|XIuWFNgɑ΂eLXgXg[擾</li>
	 * </ol>
	 * @param request
	 * @param response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doTest1(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		/*
		 * Rec^Cvݒ
		 * 
		 * void HttpServletResponse.setContentType(String type) 
		 * void HttpServletResponse.setContentLength(int len) 
		 */
		response.setContentType("text/html;charset=Shift_JIS");
		
		/*
		 * X|Xwb_ݒ
		 * 
		 * void    HttpServletResponse.setHeader(String name, String value)
		 * void    HttpServletResponse.addHeader(String name, String value)
		 * void    HttpServletResponse.setIntHeader(String nameCint value) 
		 * void    HttpServletResponse.addIntHeader(String nameCint value) 
		 * void    HttpServletResponse.setDateHeader(String nameClong date) 
		 * void    HttpServletResponse.addDateHeader(String nameClong date) 
		 * boolean HttpServletResponse.containsHeader(String name)  
		 */
		response.setHeader("Last-Modified",     "Sat, 01 Apr 2006 15:49:15 GMT");
		response.setHeader("X-ScwcdTestHeader", "see http://www.ietf.org/rfc/rfc2616.txt 6.2 Response Header Fields.");
		response.setIntHeader("X-IntegerValue", 1971);
		response.setDateHeader("X-DataValue",   System.currentTimeMillis());
		
		/*
		 * eLXgXg[擾
		 * 
		 * PrintWriter ServletResponse.getWriter()
		 */
		PrintWriter out = response.getWriter();
		
		out.println("<html><head></head><body>");
		out.println("<h1>Http Response Header ݒ肷</h1><hr/>");
		out.println("<ul>");
		out.println("<li>X|Xwb_ݒ肵Ă܂B[Last-Modified, X-ScwcdTestHeader, X-IntegerValue, X-DataValue]</li>");
		out.println("<li>X|XIuWFNg̃Rec^Cvݒ肵Ă܂B[text/html;charset=Shift_JIS]</li>");
		out.println("</ul>");
		out.println("AvbgsāAwb_[mFĂ");
		out.println("</body></html>");
	}
	
	/**
	 * <ol>
	 * <li>X|XIuWFNgɑ΂oCiXg[擾</li>
	 * </ol>
	 * @param request
	 * @param response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doTest2(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		
		/*
		 * oCiXg[擾
		 * 
		 * ServletOutputStream ServletResponse.getOutputStream() 
		 */
		response.setContentType("application/jar");
		String path = getServletContext().getRealPath("/jsp/swc.jar");
		
		FileInputStream in = new FileInputStream(new File(path));
		OutputStream   out = response.getOutputStream();
		
		byte[] buf = new byte[255];
		while ( in.read(buf) >= 0) {
			out.write(buf);
		}
		out.close();
		in.close();
	}
	
	/**
	 * <ol>
	 * <li>URLHTTPNGXg_CNg</li>
	 * </ol>
	 * @param request
	 * @param response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doTest3(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		/*
		 * HTTPNGXg_CNg
		 * 
		 * void HttpServletResponse.sendRedirect(String location) 
		 */
		String url = "http://www.google.co.jp/search?hl=ja&q=scwcd&lr=lang_ja";
		response.sendRedirect(url);
	}

	/**
	 * <ol>
	 * <li>X|XIuWFNgɃNbL[ǉ</li>
	 * </ol>
	 * @param request
	 * @param response
	 * @throws ServletException
	 * @throws IOException
	 */
	protected void doTest4(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		response.setContentType("text/html;charset=Shift_JIS");
		
		/*
		 * NbL[ǉ
		 * 
		 * void HttpServletResponse.addCookie(Cookie cookie) 
		 */
		Cookie cookie = new Cookie("request_time", (new Date()).toString() );
		response.addCookie(cookie);
		
		PrintWriter out = response.getWriter();
		out.println("<html><head></head><body>");
		out.println("Cookie݂܂<br/>");
		out.println("<a href='/scwcd/jsp/Section1_2.jsp'>mF</a>");
		out.println("</body></html>");
	}
}
