package simpletag;

import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.DynamicAttributes;
import javax.servlet.jsp.tagext.SimpleTagSupport;

public class Sec9_2DynamicAttrSimpleTag extends SimpleTagSupport implements DynamicAttributes {

	private String date = "";
	private int movemonth = 0;
	
	public void setDate(String date) {
		this.date = date;
	}
	
	/* 
	 * JSP2.0 ł́ADynamicAttributes C^[tF[X񋟂ĂA TLDɂāA
	 * dynamic-attributes  true ɐݒ肷邱ƂɂATLDŖ`̑𓮓Iɗpł悤ɂȂ
	 * 
	 * @see javax.servlet.jsp.tagext.DynamicAttributes#setDynamicAttribute(java.lang.String, java.lang.String, java.lang.Object)
	 */
	public void setDynamicAttribute(String uri, String localName, Object value) throws JspException {
		if ( "movemonth".equals(localName) ) {
			try {
				movemonth = Integer.parseInt(value.toString());
			} catch (NumberFormatException e) { }
		}
		return;
	}

	@Override
	public void doTag() throws JspException, IOException {
		JspWriter out = getJspContext().getOut();
	
		SimpleDateFormat df = new SimpleDateFormat();
		Date dt = null;
		try {
			dt = df.parse(this.date);
		} catch (ParseException e) {
			dt = new Date();
		}
		Calendar cal = Calendar.getInstance();
		cal.setTime(dt);
		
		int today = cal.get(Calendar.DATE);
		cal.set(Calendar.DATE, 1);
		cal.add(Calendar.MONTH, this.movemonth);
		int week  = cal.get(Calendar.DAY_OF_WEEK);
		
		int d = 1;
		boolean isMatch = false;
		df.applyPattern("yyyy/MM");
		out.println("<table border='1' cellspacing='0' cellpadding='0' style='font-size:x-small;text-align:center;'>");
		out.println("<caption>" + df.format(cal.getTime()) + "</caption>");
		out.println("<tr style='background-color:silver;'>");
		out.println("<td></td><td></td><td></td><td></td><td></td><td></td><td>y</td>");
		out.println("</tr>");
		
		for (int i=0; i<5; i++) {
			for (int j=Calendar.SUNDAY; j<=Calendar.SATURDAY; j++) {
				String tdstyle = "";
				if (j == Calendar.SUNDAY) {
					tdstyle = "color:red;";
					out.println("<tr>");
				}
				if (j == Calendar.SATURDAY) {
					tdstyle = "color:blue;";
				}
				
				if (!isMatch && j == week) isMatch = true;
				String ds = null;
				if (isMatch) {
					if ((this.movemonth == 0) && d == today) {
						tdstyle = tdstyle + "font-weight:bold;";
					}
					ds = "<span style='" + tdstyle + "'>" + String.valueOf(d) + "</span>";
					d++;
				} else {
					ds = "&nbsp;";
				}
				out.print("<td>" + ds + "</td>");
				if (j == Calendar.SATURDAY) out.println("</tr>");
			}
		}
		out.println("</table>");
	}
}
