package tag;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.IterationTag;
import javax.servlet.jsp.tagext.Tag;

public class Sec10_1_1IterationTag implements IterationTag {
	private PageContext context = null;
	private Tag parent = null;
	private int times = 0;
	
	public void setPageContext(PageContext context) {
		this.context = context;
	}

	public void setParent(Tag parent) {
		this.parent = parent;
	}

	public Tag getParent() {
		return this.parent;
	}

	public void setTimes(int times) {
		this.times = times;
	}
	
	public int doStartTag() throws JspException {
		if (this.times > 0) {
			return IterationTag.EVAL_BODY_INCLUDE;
		}
		return IterationTag.SKIP_BODY;
	}

	public int doAfterBody() throws JspException {
		this.times--;
		
		if (this.times > 0) {
			return IterationTag.EVAL_BODY_AGAIN;
		}
		return IterationTag.SKIP_BODY;
	}

	public int doEndTag() throws JspException {
		return IterationTag.EVAL_PAGE;
	}

	public void release() {
		this.context = null;
		this.parent = null;
	}

}
