package tag;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.StringReader;
import java.net.URLEncoder;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.BodyTag;
import javax.servlet.jsp.tagext.BodyTagSupport;
import javax.servlet.jsp.tagext.Tag;

public class Sec10_1_1OpenSourceTag extends BodyTagSupport {
	private static final long serialVersionUID = 1L;

	@Override
	public int doStartTag() throws JspException {
		
		return BodyTag.EVAL_BODY_BUFFERED;
	}

	@Override
	public int doAfterBody() throws JspException {
		
		JspWriter out = getPreviousOut();
		// JspWriter out = bodyContent.getEnclosingWriter();
		
		try {
			HttpServletRequest request = (HttpServletRequest)pageContext.getRequest();
			
			BufferedReader reader = new BufferedReader(
					new StringReader(bodyContent.getString()));
			
			String baseUri = request.getContextPath() + "/jsp/opensource.jsp?path=";
			
			String uri = null;
			String line = null;
			out.println("<ol>");
			while ((line = reader.readLine()) != null ) {
				line = line.trim();
				if (line.trim().length() > 0) {
					uri = baseUri + URLEncoder.encode(line, "UTF-8");
					out.println("<li><a href='" + uri +  "' target='_blank'>" + line + "</a></li>");
				}
			}
			out.println("</ol>");
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		return Tag.SKIP_BODY;
	}

	@Override
	public int doEndTag() throws JspException {
		return Tag.EVAL_PAGE;
	}
}
