package tag;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.tagext.Tag;
import javax.servlet.jsp.tagext.TagSupport;

public class Sec10_1_1ShowSourceTag extends TagSupport {
	private static final long serialVersionUID = 1L;

	@Override
	public int doStartTag() throws JspException {
		
		String path = getPath();
		String fullPath = pageContext.getServletContext().getRealPath(path);
		
		File file = new File(fullPath);
		
		if (file.exists()) {
			try {
				JspWriter out = pageContext.getOut();
				BufferedReader reader = new BufferedReader(new FileReader(file));
				
				String line = null;
				while ( (line = reader.readLine()) != null ) {
					out.println(toHtml(line) + "<br/>");
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		
		return Tag.EVAL_PAGE;
	}

	private String toHtml(String str) {
		str = str.replaceAll("&","&quot;");
		str = str.replaceAll("&","&amp;");
		str = str.replaceAll("<","&lt;");
		str = str.replaceAll(">","&gt;");
		str = str.replaceAll("\t","  ");
		str = str.replaceAll(" ","&nbsp;");
		return str;
	}
	
	public void setPath(String path) {
		
		setValue("path", path);
	}
	
	public String getPath() {
		
		return (String)getValue("path");
	}
}
